local ShakeDuration = 0
local WorldFrame = WorldFrame
local WorldFramePoints, fail
local UnitGUID = UnitGUID
local f = CreateFrame("Frame")
f:Hide()

f:SetScript("OnUpdate", -- only called if the frame is visible
	function(self, elapsed)
		ShakeDuration = ShakeDuration - elapsed
		if ShakeDuration < 0 then
			ShakeDuration = 0
			f:Hide()
		end
		local moveBy = math.random(-16, 16) * ShakeDuration
		WorldFrame:ClearAllPoints()
		for _, v in pairs(WorldFramePoints) do
			WorldFrame:SetPoint(v[1], v[2], v[3], v[4] + moveBy, v[5] + moveBy)
		end
	end
)

f:SetScript("OnEvent",
	function(self, _, _, event, _, sourceGUID, ...)
	--function(self, _, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2, spellId, spellName, spellSchool, ...)
		if event == "SPELL_INTERRUPT" and (sourceGUID == UnitGUID("player") or sourceGUID == UnitGUID("pet")) and ShakeDuration == 0 then
			local spell = GetSpellLink(tonumber(select(11, ...), 10))
			--if math.random(4) == 4 then
			--	SendChatMessage("Yo %t, I'm really happy for you, and Imma let you finish, but Hogger had the best " .. spell .. " of all time!")
			--else
			if GetNumPartyMembers() > 0 then
				SendChatMessage("Interrupted " .. spell, "PARTY")
			end

			if fail then return end
			if WorldFrame:IsProtected() then -- avoid taint; credit to Omen
				DEFAULT_CHAT_FRAME:AddMessage("SpellShock has been disabled; it cannot function if you have turned on nameplates at least once since logging in.")
				fail = true
			else
				WorldFramePoints = {}
				for i = 1, WorldFrame:GetNumPoints() do
					WorldFramePoints[i] = { WorldFrame:GetPoint(i) }
				end
				ShakeDuration = 1
				f:Show()
			end
		end
	end
)

f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
